<template>
  <!--This is the Header-->
  <div class="paddedDiv">
    <div class="headerContainer">
      <div class="columnLeft"></div>
      <div class="columnMiddle">
        <h1 id="siteTitle">Bear Necessities Market</h1>
      </div>
      <div class="columnBlankSpace1"></div>
      <div class="columnRight"></div>
    </div>
  </div>
  <OrderType @inputData="updateOrderTypeData" @change="verify" />
  <SubmitOrder @inputData="updateSubmitOrderData" @change="verify" />
  <DietRestrictions @inputData="updateDietData" @change="verify" />
  <OrderPreferences @inputData="updateOrderPreferenceData" @change="verify" />
  <EmailApp
    @emailOneInputData="updateEmailOneData"
    @emailTwoInputData="updateEmailTwoData"
    @change="verify"
  />
  <div class="paddedDiv">
    <div>
      <button
        type="submit"
        id="submitButton"
        :disabled="valid"
        @click="sendOrder"
      >
        Submit
      </button>
    </div>
    <HelpEmail/>
  </div>
</template>

<script>
import SubmitOrder from "./components/SubmitOrder.vue";
import OrderType from "./components/OrderType.vue";
import DietRestrictions from "./components/DietRestrictions.vue";
import OrderPreferences from "./components/OrderPreferences.vue";
import EmailApp from "./components/EmailApp.vue";
import axios from "axios";
import Swal from "sweetalert2";
import HelpEmail from './components/HelpEmail.vue';

export default {
  name: "App",
  components: {
    OrderType,
    SubmitOrder,
    DietRestrictions,
    OrderPreferences,
    EmailApp,
    HelpEmail,
  },
  data: function () {
    return {
      orderTypeData: "",
      submitOrderData: [],
      dietData: "",
      orderPreferenceData: "",
      emailOneData: "",
      emailTwoData: "",
      valid: true,
    };
  },
  methods: {
    updateOrderTypeData(newOrderTypeData) {
      this.orderTypeData = newOrderTypeData;
    },
    updateSubmitOrderData(newSubmitOrderData) {
      this.submitOrderData = newSubmitOrderData;
    },
    updateDietData(newDietData) {
      this.dietData = newDietData;
    },
    updateOrderPreferenceData(newOrderPreferenceData) {
      this.orderPreferenceData = newOrderPreferenceData;
    },
    updateEmailOneData(newEmailOneData) {
      this.emailOneData = newEmailOneData;
    },
    updateEmailTwoData(newEmailTwoData) {
      this.emailTwoData = newEmailTwoData;
    },

    verifyEmail(){
      if(this.emailOneData != "" &&
      this.emailTwoData != "" &&
      this.emailOneData == this.emailTwoData &&
      this.emailOneData.endsWith('@wne.edu')){
        return true
      }
      else {
        return false
      }
    },

    verify(){
      if(this.orderTypeData != "" &&
      this.submitOrderData != [] &&
      this.dietData != "" &&
      this.orderPreferenceData != "" &&
      this.verifyEmail()){
        return (this.valid = false);
      } else {
        return (this.valid = true);
      }
    },

    sendOrder() {
      axios
        .post("http://localhost:4000/api/orders/post", {
          orderType: this.orderTypeData,
          itemsOrdered: this.submitOrderData,
          dietaryRestrictions: this.dietData,
          commentsPreferences: this.orderPreferenceData,
          email: this.emailOneData,
          emailVerified: true,
        })
        .then(function (response) {
          console.log(response);
          Swal.fire({
            title: "Thank you!",
            text: "Your Order Has Been Placed",
            confirmButtonColor: "#0062ff",
            icon: "success",
          });
        })
        .catch(function (error) {
          console.log(error);
          //format for when API is integrated
          //  Swal.fire({
          //  title: "Oops!",
          //  text: 'Something went wrong',
          //  confirmButtonColor: '#0062ff',
          //  icon: 'error',
          //})
          Swal.fire({
          title: "Oops!",
          text: 'Something went wrong',
          confirmButtonColor: '#0062ff',
          icon: 'error',
          })
        });
    },
  },
};
</script>

<style>
@import "./css/Header.css";
@import "./css/App.css";
@import "./css/StyledDiv.css";
@import "./css/SubmitButton.css";
@import "../node_modules/sweetalert2/dist/sweetalert2.css";
</style>
